;*************************************************************
; Nastaveni portu
;*************************************************************
;RA0, RA1 a RB7/3 vystupy
;*************************************************************
; Definice symbolu
;*************************************************************
TMP2	equ	10h
TMP1	equ	11h
TMP0	equ	12h
SWR	equ	03h
PortA	equ	05h
PortB	equ	06h
#define	Z	SWR,2
#define	E	PortA,0		;PortA
#define	RS	PortA,1
#define	LED	PortB,3		;PortB
;*************************************************************
; Podprogramy cekani
;*************************************************************
;.................................
; cekej vice nez 15 ms
;.................................
; pro inicializaci LCD
;.................................
; 15000/773 =  19,40491591203
; TMP1 = 13h (.19) TMP0= 00 .... 14693 mikrosekund
; 307/3=  102,3333333333
; TMP1 = 13h, TMP0 = 66h ..... 14999 mikrosekund
; TMP1 = 0ffh, TMP0 = 66h ..... 198891 mikrosekund
; v cekacich smyckach 
;.................................
; celkem 15002 mikrosekund
;.................................
cek15m	movlw	13h
	movwf	TMP1
	movlw	66h
	movwf	TMP0
	goto	cekej
;.................................
; cekej vice nez 4,1 ms
;.................................
; pro inicializaci LCD
;.................................
; celkem 4.102 ms
;.................................
cek4m	movlw	05h
	movwf	TMP1
	movlw	4ch
	movwf	TMP0
	goto	cekej
;.................................
; cekej vice nez 1,64 ms
;.................................
; Doba pro provedeni instrukce LCD
; ClrDsp a Home
;.................................
cek1m6	movlw	1ch
	movwf	TMP0
	movlw	03h
	movwf	TMP1
	goto	cekej
;.................................
; cekej vice nez 100 mikrosekund
;.................................
; pro inicializaci LCD
;.................................
; celkem 101 mikrosekund
;.................................
cek100	movlw 	1Fh
	movwf	TMP0
	clrf	TMP1
	goto	cekej
;.................................
; cekej vice nez 40 mikrosekund
;.................................
; Doba pro provedeni instrukce LCD
; (mimo ClrDsp a Home)
;.................................
cek40	movlw	0Ah
	movwf	TMP0
	clrf	TMP1
;.............................................................
; Dobu urcuje obsah TMP1 a TMP0
;.............................................................
; Pro instrukcni cyklus 1 mikrosekunda je doba cekani 
; v mikrosekundach
; TMP1=0, TMP0=n, cekani = 3+3*n pro n=1,2,0ff,0=256
; max. 771 mikrosekund (TMP0 = 00h)
;..................................................
; TMP1=n, TMP0=01, cekani = 6+773*n
; max. 197121 mikrosekund (TMP1=0ffh, TMP0=01h) 
;..................................................
;max. 198 891 mikrosekund (TMP1=0ffh, TMP0=00h)
;.............................................................
cekej	decfsz TMP0,f
	goto	 cekej
	movfw	 TMP1
	btfsc	 Z
	retlw	 00h
	decf	 TMP1,f
	goto	 cekej
;*************************************************************
; Prenos dat (wrdata) a prikazu (wrcmd) do LCD
;*************************************************************
; prikaz nebo data musi byt pred volanim podprogramu ve W reg.
;.............................................................
wrdata	bsf	RS		;volba Registru dat v LCD
	goto	wr1
wrcmd	bcf	RS		;volba Instrukcniho registru vLCD
wr1	movwf	TMP2		;data pro vyslani do TMP0
	bsf	E		;nastav Enable
;................................
	movlw	0fh		;stav LED displeje nemenit
	iorwf	TMP2,w
	btfss	LED
	andlw	0f7h
;................................
	movwf	PortB		;horni pulbyte dat na DB7/4
	bcf	E		;ukonci Enable
	bsf	E		;nastav Enable
;................................
	swapf	TMP2,w
	iorlw	0fh
	btfss	LED
	andlw	0f7h
;................................
	movwf	PortB		;dolni pulyte dat na DB7/4
	bcf	E		;ukonci Enable
	btfsc	RS		;pokud slo o zapis dat
	goto	wr2		;cekej 40 mikrosekund
;.............................................................
	movlw	01h		;pokud slo o instrukci Display
	subwf	TMP2,W		;Clear, cekej 1.64 ms
	bz	wr3
	movlw	02h		;pokud slo o instrukci Home,
	subwf	TMP2,W		;cekej 1.64 ms
	bz	wr3
	movlw	03h		;pokud slo o instrukci Home,
	subwf	TMP2,W		;cekej 1.64 ms
	bz	wr3
;.............................................................
wr2	call	cek40		;cekej 40 mikrosekund
	return
;.............................................................
wr3	call	cek1m6		;cekej 1.6 ms
	return
;*************************************************************
; inicializace LCD po zapnuti
;*************************************************************
iniLCD	call	cek15m		
	bcf	RS
	bsf	E		;vysle do DB7/4 trojku
	movlw	30h
	movwf	PortB
	bcf	E
	call	cek4m
	bsf	E		;vysle do DB7/4 trojku
	bcf	E
	call	cek100
	bsf	E		;vysle do DB7/4 trojku
	bcf	E
	call	cek40
;............................
	movlw	20h		;4 bitova komunikace
	call	wrcmd
;............................
	movlw	28h		;2 radky, 5x7 znak
	call	wrcmd
	movlw	08h		;Display OFF
	call	wrcmd
	movlw	0ch		;Display ON
	call	wrcmd		
	movlw	06h		;Inkrementace, normalni mod
	call	wrcmd
;............................
	return
;*************************************************************
	end
