;************************************************************
; Podprogramy pro rizeni I2C sbernice pro MASTER
; ------------------------------------------------------------------------------
; INICIALIZACE
; RB0 je SDA nastaven jako vstup, PortB(0) = 0 (vzvod v H diky pull up odporu)
; RB1 je SCL nastaven jako vstup, PortB(1) = 0 (vzvod v H diky pull up odporu)
;************************************************************
; Definice symbolu
;************************************************************
SWR	equ	03h
PortB	equ	06h
TRISB	equ	06h
BITS	equ	10h
TRDat	equ	11h
PSW	equ	12h
f	equ	1
w	equ	0
;----------------------------------------------
#define	C	SWR,0
#define	RP0	SWR,5
#define	SDA	PortB,0
#define	SCL	PortB,1
#define	ACKF	PSW,0
;************************************************************
; Podprogram pro START sekvenci
;************************************************************
i2csta	bsf	RP0
	bcf	SDA
	nop
	nop
	nop
	bcf	SCL
	bcf	RP0
	return
;************************************************************
; Podprogram STOP sekvence
;************************************************************
i2cstp	bsf	RP0
	bsf	SCL
	bcf	RP0
i2csp1	btfss	SCL		;cekej na uvolneni SCL SLAVEm
	goto	i2csp1
	bsf	RP0
	bsf	SDA
	bcf	RP0
	return
;************************************************************
; Podprogram zapisu bytu do SLAVE
;--------------------------------------------------------------------------------------------------------
; Byte dat pro vysilani je ulozen v TRDat
; Po ukonceni podprogramu je v PSW (ACKF) priznak prichodu ACK ze SLAVE
;************************************************************
i2ctxd	movlw	08h		;pocet prenasenych bitu
	movwf	BITS
	bsf	RP0	
;---------------------------------------------------------
i2ctx1	rlf	TRDat,f		;vyslani bitu dat
	bcf	SDA		;nastav SDA podle bitu dat
	btfsc	C
	bsf	SDA	
	bsf	SCL		;SCL do 1
	bcf	RP0
i2ctx2	btfss	SCL		;cekej na uvolneni SCL SLAVEm
	goto	i2ctx2
	bsf	RP0
	bcf	SCL		;SCL do 0
	decfsz	BITS,f
	goto	i2ctx1
;---------------------------------------------------------
	nop			;cekej 4 ms
	bsf	SCL	
	bcf	RP0
i2ctx3	btfss	SCL		;cekej na uvolneni SCL SLAVEm
	goto	i2ctx3
	bsf	ACKF		;test ACK
	btfsc	SDA
	bcf	ACKF
	bsf	RP0		;SCL do nuly
	bcf	SCL
	bcf	RP0
	return
;************************************************************
; Podprogram pro cteni dat ze SLAVE
;--------------------------------------------------------------------------------------------------------
; Podprogram prijme data a ulozi je do TRDat
; Je-li nastaveno ACKFdo jednicky, vysle po prijeti bytu ACK,
; v opacnem pripade ACK nevysle.
;************************************************************
i2crxd	bsf	RP0		;SDA jako vstup
	bsf	SDA
	movlw	08h		;BITS nastav na 08
	movwf	BITS
	bsf	RP0
;----------------------------------------------------------
i2crx1	bsf	SCL		;SCL do 1
	bcf	RP0
i2crx2	btfss	SCL		;cekej na uvolneni SCL SLAVEm
	goto	i2crx2
	rrf	PortB,w		;SDA do TRDat
	rlf	TRDat,f
	bsf	RP0
	bcf	SCL		;SCL do 0
	decfsz	BITS,f
	goto	i2crx1
;--------------------------------------------------------
	btfsc	ACKF		;je-li ACKF = 1 vysli ACK
	bcf	SDA
	bsf	SCL		;SCL do 1
	bcf	RP0
i2crx3	btfss	SCL		;cekej na uvolneni SCL SLAVEm
	goto	i2crx3
	bsf	RP0
	bcf	SCL		;SCL do 0
	return
;************************************************************
	end
