;********************************************************************
; Tlacitko Tla0 rozsviti LED0, pri dalsim stisku opet zahsne LED0 atd.
; Zmena stavu tlacitka Tla1 prepne LED1
; (je-li rozsvicena, zhasne ji a naopak)
;********************************************************************
; PVKpro DIP SW4/1 - OFF, DIP SW5 - ON
; K Portu A 1/0 pripojena bezzakmitova tlacitka Tla1/0
; aby LED svitily, musi byt RA4 v L
;********************************************************************
; Definice symbolu
;********************************************************************
PortA	equ	05h
TrisA	equ	05h
PortB	equ	06h
TrisB	equ	06h
SWR	equ	03h
;.................................................................
w	equ	0
f	equ	1
;.................................................................
#define	Z	SWR,2		;registr volby stranky pameti dat
#define	RP0	SWR,5		;registr volby stranky pameti dat
#define	Tla0	PortA,0		;vstup s pripojenym tlacitkem Tla0
#define	Tla1	PortA,1		;vstup s pripojenym tlacitkem Tla1
#define	NLED0	PortB,0		;katoda LED0
#define	NALED	PortA,4		;anody LED
;.................................................................
RVSTUP	equ	10h
REGTLF	equ	11h
PSW	equ	12h
;.................................................................
#define	TLAKCF	PSW,7		;priznak - akceptovan stisk tlacitka Tla0
#define	Tla0F	REGTLF,0	;priznak zmeny stavu Tla0
#define	Tla1F	REGTLF,1	;priznak zmeny stavu Tla1
;********************************************************************
	org	0000h
;.................................................................
; inicializace portu
;.................................................................
start	movlw	03h		;PortB1/0 vystupy v H
	movwf	PortB		;(LED1/0 zhasnute)
	movlw	0fh		;PortA4 vystup v L
	movwf	PortA		;(pripoji anody LED diod k napajeni)
	bsf	RP0		;konfigurace I/O vyvodu
	movlw	B'11111100'	;PortB0 vystup
	movwf	TrisB
	movlw	B'00001111'	;PortA4 vystup
	bcf	RP0
;.................................................................
	movfw	PortA		;stav vstupu do RVSTUP
	movwf	RVSTUP
	clrf	REGTLF		;vynuluj registry s priznaky
	clrf	PSW
;.................................................................
hl1	movfw	PortA		;test - zmenil se stav vstupu?
	xorwf	RVSTUP,w
	bz	hl2		;stav vstupu se nezmenil
	movwf	REGTLF		;zmenil se, modifikuj registr priznaku
	movfw	PortA		;a registr vstupu
	movwf	RVSTUP
;.................................................................
hl2	btfsc	Tla0		;test - stisknute Tla0?
	goto	hl4
	bcf	TLAKCF
hl3	btfss	Tla1F		;test - doslo ke zmene stavu Tla1?
	goto	hl1
	movlw	02h		;prepni LED1
	xorwf	PortB,f
	bcf	Tla1F
	goto	hl1				
;.................................................................
hl4	btfsc	TLAKCF		;test - byl jiz akceptovan stisk Tla0?
	goto	hl3
	movlw	01h		;nebyl jeste akceptovan - prepni LED0
	xorwf	PortB,f
	bsf	TLAKCF
	goto	hl3
;********************************************************************
	end
