;*************************************************************
; Tlacitko Tl6 zhasne LEDa, Tl7 LEDa rozsviti
;*************************************************************
; PVKpro DIP SW5/1 - OFF
; K portu A 0 pripojena nizkoprikonova LEDa katodou, jeji anoda 
; pres R = 4k7 pripojit k +5 V desky PVKpro
; aby LED svitila, musi byt RA0 v L
;*************************************************************
; Definice symbolu
;*************************************************************
PortA	equ	05h
TrisA	equ	05h
PortB	equ	06h
TrisB	equ	06h
SWR	equ	03h
INTCON	equ	0bh
PSW	equ	10h
;.............................................................
#define	RP0	SWR,5		;volba stranky pameti dat
#define	Tl7	PortB,7		;vstup s tlacitkem Tl7
#define	Tl6	PortB,6		;vstup s tlacitkem Tl6
#define	NLEDa	PortA,0		;katoda LEDa
#define	RBIF	INTCON,0	;priznak preruseni od RB
#define	ONF	PSW,7		;priznak zapni LED
#define	OFFF	PSW,0		;priznak vypni LED
;*************************************************************
	org	0000h
;.............................................................
	goto	start
;.............................................................
	org	0004h
;.............................................................
; obsluha preruseni
;.............................................................
prerus	btfss	Tl6
	bsf	OFFF		;Tl6 je stisknute
	btfss	Tl7
	bsf	ONF		;Tl7 je stisknute
	bcf	RBIF
	retfie
;.............................................................
; inicializace portu a registru
;.............................................................
start	movlw	01h		;PortA0  vystup v H
	movwf	PortA		;(LEDa zhasnuta)
	bsf	RP0		;konfigurace I/O vyvodu
	movlw	B'11000000'	;PortB7/6 vstupy
	movwf	TrisB
	movlw	B'00011110'	;PortA0 vystup
	movwf	TrisA
	bcf	RP0
	movlw	B'10001000'	;Povoleni preruseni od RB
	movwf	INTCON
	clrf	PSW		;vynuluj stav. slovo programu
;.............................................................
hl1	btfsc	OFFF			
	goto	hl2		;FOFF = 1, zhasni LEDa
	btfss	ONF
	goto	hl1
	bcf	NLEDa		;FON = 1, rozsvit LEDa
	bcf	ONF
	goto	hl1
;.............................................................
hl2	bsf	NLEDa		;zhasni LEDa	
	bcf	OFFF
	goto	hl1
;*************************************************************
	end
