;*************************************************************
; Tlacitko Tl0 zhasne/rozsviti LEDa0, LEDa1 blika v intervalu
; 1 sec
;*************************************************************
; PVKpro DIP SW4/0 - OFF
; K portu A0,1 pripojena nizkoprikonova LEDa0,1 katodou,
; jejich anody pres R = 4k7 pripojit k +5 V desky PVKpro
; aby LED svitily, musi byt RA0,1 v L
;*************************************************************
; Definice symbolu
;*************************************************************
OPTREG	equ	01h
TMR0	equ	01h
PortA	equ	05h
TrisA	equ	05h
PortB	equ	06h
TrisB	equ	06h
SWR	equ	03h
INTCON	equ	0bh
PSW	equ	10h
CASMS	equ	11h
TMPW	equ	12h
TMPSWR	equ	13h
f	equ	1
w	equ	0
;.............................................................
#define	RP0	SWR,5		;volba stranky pameti dat
#define	NLEDa0	PortA,0		;katoda LEDa0
#define	NLEDa1	PortA,1		;katoda LEDa1
#define	INTF	INTCON,1	;priznak preruseni od INT
#define	RTIF	INTCON,2	;priznak preruseni od TMR0
#define	GIE	INTCON,7	;globalni povoleni preruseni
#define	SECF	PSW,7		;uplynula jedna sekunda
;*************************************************************
	org	0000h
;.............................................................
	goto	start
;.............................................................
	org	0004h
;.............................................................
; obsluha preruseni
;.............................................................
prerus	movwf	TMPW		;uloz stav W a SWR
	movfw	SWR
	movwf	TMPSWR
; ....................................
	btfsc	INTF
	goto	prer1
	btfsc	RTIF
	goto	prer2
;....................................
prer0	movfw	TMPSWR		;obnov stav SWR a W
	movwf	SWR
	movfw	TMPW
	retfie
;....................................
prer1	bcf	INTF		;obsluha prer. od stisku Tl0
	movlw	B'00000001'	;prepni LEDa0
	xorwf	PortA,f
	goto	prer0
;....................................
prer2	bcf	RTIF		;obsluha prer. od TMR0
	incf	CASMS,f
	movlw	.100		;pokud uplynula 1 sec
	subwf	CASMS,w
	bnz	prer0
	bsf	SECF		;nastav priznak F1SEC
	clrf	CASMS
	goto	prer0
;.............................................................
; inicializace portu a registru
;.............................................................
start	movlw	03h		;PortA0,1  vystupy v H
	movwf	PortA		;(LEDa zhasnuta)
	clrf	TMR0
	bsf	RP0		;konfigurace I/O vyvodu
	movlw	B'00000001'	;PortB0 vstup
	movwf	TrisB
	movlw	B'00011100'	;PortA0,1 vystupy
	movwf	TrisA
	movlw	B'00000100'	;preddelic mezi TMR0 a OSC
	movwf	OPTREG		;preddelic :32,aktivni
	bcf	RP0		;spadova hrana na RB0 (INT)
	movlw	B'10110000'	;Povoleni preruseni od INT
	movwf	INTCON		;a TMR0
	clrf	PSW		;vynuluj stav. slovo programu
	clrf	CASMS		;ynuluj citac desitek ms
;.............................................................
hl1	btfss	SECF
	goto	hl1			
	bcf	SECF		;vynuluj priznak uplynula 1 sec
	movlw	B'00000010'	;prepni LEDa1
	xorwf	PortA,f
;*************************************************************
	end
